const
	script_name='dvdempire';
	language='English';
	version=17;
	author='Alex';
	MinProgramBuild=4100;
	Dbg = false;
	PCount = 12;
var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments, 
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList, DownloadMovieTechnicalInfo: boolean;
	MaxShotsCount: integer;

	title, MovieName, year, director, name, character, BasicURL, country, description, salary: string;
	movie_code, movie_site_url, title_code, imdb_code: string;
	code: string;
	duration: integer;
	imdb_rating: single;
	front_cover_url, cover_code: string;
	posters_exists, boxes_exists, screenshots_exists: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	awards: string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	duration_min: integer;
	//subtitles, AudioTracks: array of string;
	//SubtitlesCount, AudioTracksCount: integer;

function MovieSearch: integer;
var
	i, j, ii, jj, TitlesCount: integer;
	s, s2, s3, year, original_title, description, small_cover: string;
begin
	s:='';
	TitlesCount:=0;
	
	i:=pos('<strong>0</strong> Matches Found', all);
	if (all='') or (i>0) then
		// Movie not found!
	else 
	begin
		i:=pos('<table width=''100%'' border=''0'' cellspacing=''0'' cellpadding=''0''><tr><td colspan=''4''>',all);
		if i>0 then
		begin
			ii:=MyPos('</td></tr><tr><td valign=''top'' align=''right''>', all, i+1);
			if ii>0 then
			repeat
				jj:=MyPos('width=''140'' height=''1'' align=''left'' border=''0''>', all, ii+1);
				if jj>0 then
				begin
					s3 := copy(all,ii,jj-ii);
					
					//cover
					small_cover := '';
					i := Pos('<a href', s3);
					i := MyPos('<img src=''', s3, i+1);
					if i>0 then begin
						j := MyPos('''', s3, i+11);
						small_cover := copy(s3, i+10, j-i-10);
					end;
					
					//year
					year := '';
					i := Pos('<nobr>Prod Year: ', s3);
					j := MyPos('</nobr>', s3, i+1);
					if (i>0)and(j>0) then begin
							i := i + 17;
							year := copy(s3,i,j-i);
					end;
					
					//description
					description := '';
					description := ParseString(s3, '<br>Cast:(.*?)<nobr>more', 1);
					description := RemoveTags(description);
					description := DecodeHTML(description);
					
					//original_title
					original_title := '';
					
					i:=Pos('<b><a href=', s3);
					i:=MyPos('item_id=', s3, i+1);
					j:=MyPos('''>', s3, i+1);
					if (i<>0)and(j<>0) then
					begin
						i := i + 8;
						title_code := copy(s3,i,j-i);
						i := j + 2;
						j := MyPos('<', s3, i+1);
						title := copy(s3,i,j-i);
						title := RemoveTags(title);
						title := DecodeHTML(title);
						title := ClearExtraSpaces(title);
						
						i := MyPos('<span class=''fontsmall3''>&nbsp;<nobr><b>', s3, j+1);
						j := MyPos('</b></nobr></span>', s3, j+1);
						if (i<>0)and(j<>0) then
						begin
							s2 := '<span class=''fontsmall3''>&nbsp;<nobr><b>';
							i := i + length(s2);
							s2 := copy(s3,i,j-i);
							title := title + ' (' + s2 + ')';
								
							TitlesCount := TitlesCount + 1;
							SetSearchResult2(title, title_code, year, original_title, description, small_cover);
						end;
					end;
					ii := jj;
				end;
			until (jj=0);
		end;
	end;
	result:=TitlesCount;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName: string; AYear: string; ABarcode: string): string;
var
	url: string;
begin
	if ABarcode <> '' then begin
		url := format('http://www.dvdempire.com/Exec/v1_search_all.asp?string=%%22%s%%22&&site_media_id=&site_id=&pp=3&sort=', [ABarcode]);
	end
	else
		url:=format('http://www.dvdempire.com/Exec/v1_search_all.asp?string=%%22%s%%22&&site_media_id=&site_id=&pp=3&sort=', [MovieName]);
	url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
	if images_only then
		result:=format('http://www.dvdempire.com/Exec/v4_item.asp?item_id=%s', [code])
	else
		result:=format('http://www.dvdempire.com/Exec/v4_item.asp?item_id=%s', [code])
end;

//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
		  fs:=TFileStream.Create(FileName, fmCreate);
  		fs.Write(s, Length(s));
		  fs.Free;
		  result:=true;
	  except
	  	result:=false;
	  end;
	end
	else
		result:=false;
end;

function ClearBrackets(name: string): string;
var
	i: integer;
begin
	// clear word in brackets at the end of name
	i := pos(' (', name);
	if i>0 then
		name := copy(name, 1, i-1);
	Result := name;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes "
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

//Parse Audio Tracks to Movienizer's format
function ParseAudioTrack(s: string): string;
var
	i: integer;
	s2, lang, suf, codec: string;
begin
	result:=s;
	i:=pos(': ', s);
	if i>0 then begin
		s2:=copy(s, 1, i-1);
		delete(s, 1, i+1);
		s2:=LowerCase(s2);
		if length(s2)>0 then
			s2[1]:=UpperCase(s2[1]);
		i:=pos(' [', s);
		if i>0 then begin
			suf:=copy(s, i, length(s)-i+1);
			s:=copy(s, 1, i-1);
		end
		else
			suf:='';
		if s='Dolby Digital Stereo' then
			codec:='AC3 2 ch'
		else if s='Dolby Digital 5.1' then
			codec:='AC3 5 ch'
		else
			codec:=s;
		lang:=s2;
		result:=format('%s %s%s', [lang, codec, suf]);
	end;
end;

//get movie info
function GetInfo(url: string; images_only: boolean): string;
const
	title_junk=['edition', 'screen', 'lenticular', 'feature', 'director''s'];
var
	s, s2, s3, keyword: string;
	i, j, k: integer;
begin
	result:='';
	BasicURL:=url;
	all:=DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;

	imdb_code:='';

	//remove facebook link
	i := Pos('<strong>Like Us on Facebook</strong>', all);
	if i>0 then
		delete(all, i, 36);
	//title
	i := pos('<strong>', all);
	if i>0 then begin
		j := MyPos('</strong>', all, i + 1);
		title:=copy(all, i+8, j-i-8);
	end;
	
	//remove garbage
	i := Pos('(', title);
	if i>0 then begin
		j := MyPos(')', title, i+1);
		s := copy(title, i, j-i);
		for k := 0 to length(title_junk) - 1 do begin
			if (Pos(title_junk[k], LowerCase(s))>0) then
				delete(title, i, length(title) - i + 1);
		end;
	end;
	i := Pos(' - ', title);
	if i>0 then begin
		s := copy(title, i, length(title) - i + 1);
		for k := 0 to length(title_junk) - 1 do begin
			if (Pos(title_junk[k], LowerCase(s))>0) then
				delete(title, i, length(title) - i + 1);
		end;		
	end;
	i := Pos(':', title);
	if i>0 then begin
		s := copy(title, i, length(title) - i + 1);
		for k := 0 to length(title_junk) - 1 do begin
			if (Pos(title_junk[k], LowerCase(s))>0) then begin
				title := copy(title, 1, i-1);
			end;
		end;
	end;

	title := ClearExtraQuotes(title);
	title := MovePrefixLeft(title);
	title := ClearExtraSpaces(title);
	if title='' then
		exit;

	movie_code:=ParseString(BasicURL, 'http://www.dvdempire.com/Exec/v4_item.asp\?item_id=(\d+)', 1);
	movie_site_url:=GetMovieSiteURL(movie_code);

	//movie year
	year:=ParseString(all, '<b>Production Year:</b> (\d+)', 1);

	//mpaa
	mpaa:='';
	mpaa_rating:='';
	i:=pos('<b>Rating:</b> ', all);
	if i>0 then begin
		j:=MyPos('<br />', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			delete(s2, 1, 15);
			if s2<>'' then
				mpaa:=s2;
		end;
	end;


	//plot
	i:=pos('<b>Synopsis</b>', all);
	if i>0 then begin
		i:=MyPos('<table ', all, i+1);
		if i>0 then begin
			j:=MyPos('</table>', all, i+1);
			if j>0 then begin
				description:=copy(all, i, j-i);

				description:=ParseString(description, '.*<td width="100%" valign="top" class="fontsmall3">(.*)</td>.*', 1);
				if pos('<i><font color="blue">', description)>0 then
					description:=ParseString(description, '</font></i><br /><br />(.*)$', 1);
				description:=ReplaceStr(description, '</p>', #10, -1);
				description:=ReplaceStr(description, '<font face=''arial, sans-serif'' size=''2'' color=''#FFFFFF''>i</font>', ' ', -1);
				description:=RemoveTags(description);
				description:=ClearExtraCharacters(description);
				description:=ClearExtraSpaces(description);
				description:=ReplaceStr(description, #10, '<br>', -1);
			end;
		end;
	end;

	//directors
	i:=pos('<b>Directors:</b><br />', all);
	if i>0 then begin
		j:=MyPos('</a><br /><', all, i+1);
		if j>0 then begin
			j := j + 10;
			s2:=copy(all, i, j-i);
			i:=Pos('<a href="/Exec/v4_list_cast.asp?userid=', s2);
			delete(s2, 1, i-1);
			if length(s2)>0 then begin
				i:=pos('<br />', s2);
				while i>0 do begin
					s3:=copy(s2, 1, i-1);
					code:=ParseString(s3, '<a href="/Exec/v4_list_cast.asp\?cast_id=(\d+)', 1);
					name:=ParseString(s3, '<a href="/Exec/v4_list_cast.asp\?cast_id=\d+">(.*?)</a>', 1);
					name:=RemoveTags(name);
					if name<>'' then begin
						SetPersonName(name, '', 1, code);
					end;
					delete(s2, 1, i+4);
					i:=pos('<br />', s2);
				end;
			end
		end;
	end;
	
	//writers
	i:=pos('<b>Writers:</b><br />', all);
	if i>0 then begin
		j:=MyPos('</a><br /><', all, i+1);
		if j>0 then begin
			j := j + 10;
			s2:=copy(all, i, j-i);
			i:=Pos('<a href="/Exec/v4_list_cast.asp?', s2);
			delete(s2, 1, i-1);
			if length(s2)>0 then begin
				i:=pos('<br />', s2);
				while i>0 do begin
					s3:=copy(s2, 1, i-1);
					code:=ParseString(s3, '<a href="/Exec/v4_list_cast.asp\?cast_id=(\d+)', 1);
					name:=ParseString(s3, '<a href="/Exec/v4_list_cast.asp\?cast_id=\d+">(.*?)</a>', 1);
					name:=RemoveTags(name);
					if name<>'' then begin
						SetPersonName(name, '', 2, code);
					end;
					delete(s2, 1, i+4);
					i:=pos('<br />', s2);
				end;
			end
		end;
	end;

	//actors
	i:=pos('<b>Actors:</b><br />', all);
	if i>0 then begin
		j:=MyPos('</a><br /><', all, i+1);
		if j>0 then begin
			j := j + 10;
			s2:=copy(all, i, j-i);
			i:=Pos('<a href="/Exec/v4_list_cast.asp?', s2);
			delete(s2, 1, i-1);
			if length(s2)>0 then begin
				i:=pos('<br />', s2);
				while i>0 do begin
					s3:=copy(s2, 1, i-1);
					code:=ParseString(s3, '<a href="/Exec/v4_list_cast.asp\?cast_id=(\d+)', 1);
					name:=ParseString(s3, '<a href="/Exec/v4_list_cast.asp\?cast_id=\d+">(.*?)</a>', 1);
					name:=RemoveTags(name);
					if name<>'' then begin
						SetPersonName(name, '', 3, code);
					end;
					delete(s2, 1, i+4);
					i:=pos('<br />', s2);
				end;
			end
		end;
	end;

	//imdb rating
	imdb_rating:=0;

	//movie duration (minutes)
	s2:=ParseString(all, '<b>Length:</b> (\d+?) mins<br />', 1);
	duration:=0;
	if s2<>'' then
		try
			duration:=StrToInt(s2);
		except
		end;

		
	//movie image
	cover_code := '';
	i := Pos('org/products/', all);
	if i>0 then begin
		j := MyPos('.jpg', all, i+1);
		cover_code := copy(all, i+13, j-i-13);
		i := Pos('t', cover_code);
		if i>0 then
			delete(cover_code, i, 1);
		front_cover_url := format('http://cdn3a.dvdempire.org/products/%s.jpg', [cover_code]);
	end;

	if pos(format('item_id=%s&amp;tab=5', [movie_code]), all)>0 then
		boxes_exists:=true
	else			
		boxes_exists:=false;

	if pos(format('item_id=%s&amp;tab=6', [movie_code]), all)>0 then
		screenshots_exists:=true
	else			
		screenshots_exists:=false;

	//movie genres
	s2:=ParseString(all, '<b>Genre</b>: (.*?)</td>', 1);
	if length(s2)>0 then begin
		i:=pos('</a>', s2);
		while i>0 do begin
			s3:=copy(s2, 1, i+3);
			name:=ParseString(s3, '<a href="/exec/v2_category.asp.*?>(.*?)</a>', 1);
			if name<>'' then begin
				SetGenre(name);
			end;
			delete(s2, 1, i+3);
			i:=pos('</a>', s2);
		end;
	end;
	
	//Studio
	if DownloadMovieStudios then begin
		i := Pos('<b>Studio', all);
		if i>0 then begin
			i := MyPos('</b>', all, i+1);
			j := MyPos('</a>', all, i+1);
			s := copy(all, i, j-i);
			s := RemoveTags(s);
			s := DecodeHTML(s);
			SetStudio(s);
		end;
	end;

	//technical info
	resolution:='';
	barcode:='';
	aspect_ratio:='';
	features:='';
	duration_min:=0;
	//SubtitlesCount:=0;
	//AudioTracksCount:=0;
	media_format:='';
	video_codec:='';
	if DownloadMovieTechnicalInfo then begin
		//Screen Resolution:
		s2:='<b>Screen Resolution:</b><br /></td></tr><tr><td style=''padding-left:7px;padding-bottom:10px'' valign=''top'' width=''100%'' class=''fontsmall2''>';
		i:=pos(s2, all);
		if i>0 then begin
			j:=MyPos('</td>', all, i+length(s2));
			if j>0 then begin
				s3:=copy(all, i+length(s2), j-i-length(s2));
				//ShowMessage('='+s3+'=');
				resolution:=s3;
			end;
		end;

		//barcode
		s2:='<b>UPC Code:</b> ';
		i:=pos(s2, all);
		if i>0 then begin
			j:=MyPos('<br />', all, i+length(s2));
			if j>0 then begin
				s3:=copy(all, i+length(s2), j-i-length(s2));
				//ShowMessage('='+s3+'=');
				barcode:=s3;
			end;
		end;

		//AspectRatio
		s2:='<b>Video:</b><br /></td></tr><tr><td style=''padding-left:7px;padding-bottom:10px'' valign=''top'' width=''100%'' class=''fontsmall2''>';
		i:=pos(s2, all);
		if i>0 then begin
			j:=MyPos('</td>', all, i+length(s2));
			if j>0 then begin
				s3:=copy(all, i+length(s2), j-i-length(s2));
				i:=pos(' ', s3);
				if i>0 then
					delete(s3, 1, i);
				i:=pos(' ', s3);
				if i>0 then
					s3:=copy(s3, 1, i-1);
				//ShowMessage('='+s3+'=');
				aspect_ratio:=s3;
			end;
		end;

		//features
		s2:='<tr><td><b>Features:</b><br /></td></tr><tr><td style=''padding-left:7px;padding-bottom:10px'' valign=''top'' width=''100%'' class=''fontsmall2''>';
		i:=pos(s2, all);
		if i>0 then begin
			j:=MyPos('</td>', all, i+length(s2));
			if j>0 then begin
				s3:=copy(all, i+length(s2), j-i-length(s2));
				s3:=RemoveTags(s3);
				s3:=ReplaceStr(s3, #13#10#13#10, #13#10, -1);
				s3:=ClearExtraXCharacters(s3);
				//ShowMessage('='+s3+'=');
				features:=s3;
			end;
		end;

		//Subtitles
		s2:='<b>Subtitles:</b><br /></td></tr><tr><td style=''padding-left:7px;'' valign=''top'' width=''100%'' class=''fontsmall2''>';
		i:=pos(s2, all);
		if i>0 then begin
			j:=MyPos('</td>', all, i+length(s2));
			if j>0 then begin
				s3:=copy(all, i+length(s2), j-i-length(s2));
				i:=pos(', ', s3);
				repeat
					if i>0 then begin
						s2:=ClearExtraXCharacters(copy(s3, 1, i-1));
					  //SubtitlesCount:=SubtitlesCount+1;
					  //SetLength(subtitles, SubtitlesCount);
					  //subtitles[SubtitlesCount-1]:=s2;

						//ShowMessage('='+s2+'=');
						SetSubtitle(s2);
						delete(s3, 1, i+1);
					end
					else begin
						if s3<>'' then begin
						  //SubtitlesCount:=SubtitlesCount+1;
						  //SetLength(subtitles, SubtitlesCount);
						  //subtitles[SubtitlesCount-1]:=s3;
							//ShowMessage('='+s3+'=');
							SetSubtitle(s3);
							s3:='';
						end;
					end;
					i:=pos(', ', s3);					
				until s3='';
			end;
		end;

		//Audio tracks
		//s2:='<b>Audio:</b><span style=''font-size:0.65em;''>&nbsp;<a href=''http://www.dvdempire.com/content/guides/index.asp?site=0&tab=125&tab_id=60&site_id=4&site_media_id=0'' onclick=''window.open(this.href); return false;'' onkeypress=''window.open(this.href); return false;''>(more info)</a></span></td></tr><tr><td style=''padding-left:7px;padding-bottom:10px'' valign=''top'' width=''100%'' class=''fontsmall2''>';
		s2:='<b>Audio:</b><span style=''font-size:0.65em;''>&nbsp;';
		i:=pos(s2, all);
		if i>0 then begin
			s2:='<td style=''padding-left:7px;padding-bottom:10px'' valign=''top'' width=''100%'' class=''fontsmall2''>';
			i:=MyPos(s2, all, i+1);
			j:=MyPos('</td>', all, i+length(s2));
			if j>0 then begin
				s3:=copy(all, i+length(s2), j-i-length(s2));
				//ShowMessage(s3);
				i:=pos('<br />', s3);
				repeat
					if i>0 then begin
						s2:=copy(s3, 1, i-1);
						s2:=ClearExtraXCharacters(RemoveTags(s2));
					  //AudioTracksCount:=AudioTracksCount+1;
					  //SetLength(AudioTracks, AudioTracksCount);
					  s2:=ParseAudioTrack(s2);
					  //AudioTracks[AudioTracksCount-1]:=s2;

						//ShowMessage('='+s2+'=');
						SetAudioTrack(s2);
						delete(s3, 1, i+5);
					end
					else begin
						s3:=ClearExtraXCharacters(RemoveTags(s3));
					  //AudioTracksCount:=AudioTracksCount+1;
					  //SetLength(AudioTracks, AudioTracksCount);
					  s3:=ParseAudioTrack(s3);
					  //AudioTracks[AudioTracksCount-1]:=s3;
						//ShowMessage('='+s3+'=');
						SetAudioTrack(s2);
						s3:='';
					end;
					i:=pos('<br />', s3);					
				until s3='';
			end;
		end;

		//Media format
		s2:='<span class=''fontsmall3''><b><nobr>&nbsp;/&nbsp; ';
		i:=pos(s2, all);
		if i>0 then begin
			j:=MyPos('</a></b></nobr></span>', all, i+1);
			if j>0 then begin
				s2:='<a href=';
				i:=MyPos(s2, all, i+1);
				if i>0 then begin
					s3:=copy(all, i, j-i);
					s2:=ClearExtraXCharacters(RemoveTags(s3));
					if s2='DVD-Video' then
						s2:='DVD';
					media_format:=s2;
					//ShowMessage('='+s2+'=');
				end;
			end;
		end;

		//duration
		duration_min:=duration;

		//video codec
		//video_codec:='test';
	end;

	posters_exists:=false;
end;

//returned images links
procedure GetImages;
var
	front_cover_url_back: string;
begin
	GetFrontCoverURL;
	if boxes_exists and DownloadMovieBigCover then begin
		front_cover_url_back:=format('http://cdn3a.dvdempire.org/products/%sbh.jpg', [cover_code]);
		SetImageName('', front_cover_url_back, '', 2);
	end;
	if screenshots_exists and (MaxShotsCount>0) then
		GetScreenshots(BasicURL+'&tab=6');
end;

//returned link to front cover
function GetFrontCoverURL: string;
var
	res, all, url, s, s2, s3, amazon_url: string;
	i, j: integer;
	front_cover_url_big: string;
begin
	res:=front_cover_url;
	if boxes_exists and DownloadMovieBigCover then begin
		front_cover_url_big:=format('http://cdn3a.dvdempire.org/products/%sh.jpg', [cover_code]);
		SetImageName('', front_cover_url_big, '', 1);
		res:=front_cover_url_big;
	end
	else if front_cover_url<>'' then
		SetImageName('', front_cover_url, '', 1);
	result:=res;
end;

//get screenshots
procedure GetScreenshots(url: string);
var
	i, j, frames_count: integer;
	all, s, img_url: string;
begin
	all:=DownloadURL(url);
	frames_count:=0;
	j:=0;
	i:=pos(format('http://cdn3a.dvdempire.org/gen/screenshots/%s_%da.jpg', [movie_code, j]), all);
	while (i>0) and (frames_count<MaxShotsCount) do begin
		img_url:=format('http://cdn3a.dvdempire.org/gen/screenshots/%s_%db.jpg', [movie_code, j]);
		SetImageName('', img_url, '', 3);
		j:=j+1;
		frames_count:=frames_count+1;
		i:=MyPos(format('http://cdn3a.dvdempire.org/gen/screenshots/%s_%da.jpg', [movie_code, j]), all, i+1);
	end;
end;

//get posters
procedure GetPosters(url: string);
var
	i, j: integer;
	all, s: string;
begin
	all:=DownloadURL(url);
	i:=pos('http://posters.imdb.com/', all);
	while i>0 do begin
		j:=MyPos('"', all, i+1);
		if j>0 then begin
			s:=copy(all, i, j-i);
			SetImageName('', s, '', 4);
		end;
		i:=MyPos('http://posters.imdb.com/', all, i+1);
	end;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='http://www.dvdempire.com/Exec/v4_item.asp?item_id='+code;
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	result:='';
end;

begin

DownloadMovieTechnicalInfo:=false;

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.